CREATE CACHED TABLE Product(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Name Varchar(200),

	ParentId Integer,
    Notes Varchar(500),

    BudgetAmount BigInt,
    BudgetPeriodType Integer,
    
    Deleted Bit Default FALSE
);

CREATE CACHED TABLE Vendor(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Name Varchar(200),

	ParentId Integer,
    Notes Varchar(500),

    BudgetAmount BigInt,
    BudgetPeriodType Integer,
    
    Deleted Bit Default FALSE  
);

CREATE CACHED TABLE Account(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Name Varchar(200),

	ParentId Integer,
    Notes Varchar(500),

    BudgetAmount BigInt,
    BudgetPeriodType Integer,
    
    Deleted Bit Default FALSE  
);

CREATE CACHED TABLE Reminder(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Name Varchar(200),
    Notes Varchar(1000),
	Deadline Date,
	Complete Bit,

    Deleted Bit Default FALSE  
);

-- TODO: merge expense and income

CREATE CACHED TABLE Expense(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Notes Varchar(500),
	ExpenseDate Date,
	Amount BigInt,
	ItemCount Integer,

	ParentId Integer,

	ProductId Integer,
	VendorId Integer,
	AccountId Integer,


	ScheduledExpenseId Integer,
	ScheduledDate Date,
	Deleted Bit Default FALSE,
	Reminder Bit Default FALSE
);

CREATE INDEX ExpenseDateIndex ON Expense (ExpenseDate);
/*
CREATE CACHED TABLE ExpenseEdit(
    Id Integer GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Notes Varchar(500),
	ExpenseDate Date,
	Amount BigInt,
	ItemCount Integer,

	ParentId Integer,

	ProductId Integer,
	VendorId Integer,
	AccountId Integer,

	
    Type Integer, // 0 = Delete, 1 = Edit, 2 = Complete, 3 = Move
	ScheduledDate Date
);
*/

CREATE CACHED TABLE ScheduledExpense(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Notes Varchar(500),
	StartDate Date,
	LastDate Date,
	Amount BigInt,
	ItemCount Integer,

	ProductId Integer,
	VendorId Integer,
	AccountId Integer,

	Reminder Bit Default FALSE,
    Recurrence Varchar(200)
);


CREATE CACHED TABLE ShoppingList(
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    Name Varchar(200),

    Notes Varchar(1000),
	ShoppingListDate Date,

	VendorId Integer,
	AccountId Integer,

    Deleted Bit Default FALSE  
);

CREATE CACHED TABLE ShoppingListItem (
    Id BigInt GENERATED BY DEFAULT AS IDENTITY (START WITH 1),

    Notes Varchar(1000),

    ParentId Integer,
    ProductId Integer,
    ItemCount Integer,
    Amount BigInt,

    Deleted Bit Default FALSE,
	Complete Bit Default FALSE,
	ExpenseId Integer
);

-- Initialize database
INSERT INTO Product(Name) VALUES ('Any');
INSERT INTO Vendor(Name)  VALUES ('Any');
INSERT INTO Account(Name) VALUES ('Any');

CHECKPOINT